Not every error scenario deserves its own unique error code. We need to strike a
balance between

* __Too few error codes__ where codes are too general and not descriptive enough, and
* __Too many error codes__ where a particular scenario could be represented by multiple codes.

Similarly, our error codes should be general enough to stand the test of time.
As platforms come and go and as platform-specific APIs or behaviors change, we
don't want to introduce error codes that could become obsolete or which we'll
regret later on.

Please keep these principles in mind when proposing error codes.

Additionally, before proposing a new error code, complete
[Step 0: Evaluate the need for a new Error or Warning code](https://wiki.hq.twilio.com/display/DevTool/10-7%3A+Errors+Codes+Service)
in the DevTools Team's error codes document.
