Twilio Voice Errors
===================

All Twilio Voice errors are defined in [`twilio-voice-errors.json`](twilio-voice-errors.json). Other errors already defined by Twilio are defined in [`twilio-authorization-errors.json`](twilio-authorization-errors.json) and [`twilio-rest-errors.json`](twilio-rest-errors.json).

-  Errors defined in [Twilio Client](https://www.twilio.com/docs/api/client/errors) are excluded from this branch. To ensure that new error codes do not overlap with previously defined errors, check [Twilio CLIENT error codes](https://www.twilio.com/docs/voice/client/errors) and [Twilio Error Codes](https://www.twilio.com/docs/api/errors).
- Programmable Voice uses the same error code range as Twilio Client.
- Authorization errors are defined using the `201xx` REST authorization errors instead of the range defined in Twilio Client as `312xx`.
- Twilio Error code `21218` is preferred over Twilio Client code `31001` for TwiML application not found.

Setup
-----

Ensure you have [Node](https://nodejs.org) installed. Then, run the following:

```
git clone https://code.hq.twilio.com/client/twilio-voice-errors
cd twilio-voice-errors
npm install
```

Usage
-----

### Previewing the Error Codes

This project can generate table and dictionary views of the Voice errors. Just
run the following command in the root of the project:

```
npm run generate
```

This will produce `dictionary.md` and `table.md`, respectively.

#### Previewing on GitHub

If you'd like to preview `dictionary.md` and `table.md` on GitHub, you can
automatically generate and push these artifacts to a dedicated
[`preview` branch](https://code.hq.twilio.com/client/twilio-voice-errors/tree/preview).
where you can see rendered versions of
[`dictionary.md`](https://code.hq.twilio.com/client/twilio-voice-errors/tree/preview/dictionary.md)
and [`tree.md`](https://code.hq.twilio.com/client/twilio-voice-errors/tree/preview/table.md)
rendered. Just run the following command in the root of the project:

```
npm run preview
```

### Publishing a New Version of this Specification to NPM

This project defines all Twilio Voice errors, so if you would like to add a new
error code, you must propose it and add it to this document, per
[`CONTRIBUTING.md`](CONTRIBUTING.md). Once added, you should cut a new _minor_
version of this document by updating the version number in package.json, eg
`1.0.0` -> `1.1.0`.

Make sure this version update has been committed and pushed to the primary branch.
Then, in order to publish to NPM, run:

```
npm publish
```

### Generic Twilio Errors

If you are using generic Twilio Errors that are not in `twilio-voice-errors.json`, add them to `twilio-rest-errors.json` or `twilio-authorization-errors.json` so that code can be generated for them as well.

### Code Generation

TODO: Implement code generation
